/* generate .tap file for scrolly stack
 * usage: ./maketap <main.bin >scrolly.tap
 *
 * PD by RJM
 */

#include <stdio.h>

unsigned char tapstart[]=
  {
  0x13, 0x00, 0x00, 0x00,
  'S',  'c',  'r',  'o',
  'l',  'l',  'y',  'S',
  't',  'k',  0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x4E, 0x16, 0x00, 0xFF,
  };


int main(void)
{
static unsigned char buf[16384];
int f,check_byte;
int codelen;
int baslen;

codelen=fread(buf,1,sizeof(buf),stdin);
buf[codelen]=0x0d;
codelen++;
baslen=codelen+sizeof(tapstart)-24;

tapstart[14]=tapstart[18]=baslen%256;
tapstart[15]=tapstart[19]=baslen/256;
tapstart[21]=(baslen+2)%256;
tapstart[22]=(baslen+2)/256;

check_byte=0;
for(f=3;f<20;f++)
  check_byte^=tapstart[f];
tapstart[20]=check_byte;

fwrite(tapstart,1,sizeof(tapstart),stdout);

check_byte=0xff;

for(f=0;f<codelen;f++)
  {
  putchar(buf[f]);
  check_byte^=buf[f];
  }

putchar(check_byte);

exit(0);
}
